diff --git a/lib/hive/stages/review/fix_completion.rb b/lib/hive/stages/review/fix_completion.rb
new file mode 100644
index 00000000..33fd44da
--- /dev/null
+++ b/lib/hive/stages/review/fix_completion.rb
@@ -0,0 +1,329 @@
+# frozen_string_literal: true
+
+require "json"
+require "open3"
+require "timeout"
+require "hive/protected_files"
+require "hive/stages/review/triage"
+
+module Hive
+  module Stages
+    module Review
+      # Parses the fix agent's per-pass completion evidence and independently
+      # checks repository and review-state facts. This is a probe only: it
+      # never clears markers, commits changes, or advances a review pass.
+      module FixCompletion
+        VERSION = 1
+        OUTCOMES = %w[changed no_changes_needed].freeze
+        DISPOSITIONS = [ "addressed", "no change needed" ].freeze
+        SHA = /\A[0-9a-f]{7,64}\z/.freeze
+        GIT_PROBE_TIMEOUT_SEC = 300
+        Expectation = Data.define(
+          :reviewer_digests,
+          :escalation_digest,
+          :finding_ids
+        )
+
+        module_function
+
+        def evidence_path(ctx)
+          File.join(ctx.task_folder, "reviews", "fix-result-#{format('%02d', ctx.pass)}.json")
+        end
+
+        # A prior attempt's result must not prove a fresh launch. The review
+        # runner calls this immediately before the fixer starts; ENOENT is the
+        # intended no-op, while an unreadable task state is a hard failure at
+        # probe time rather than a stale acceptance.
+        def clear_evidence!(ctx)
+          File.delete(evidence_path(ctx))
+        rescue Errno::ENOENT
+          nil
+        end
+
+        # Capture immutable review inputs before the fixer is launched. The
+        # probe receives this exact snapshot after the turn, so a fixer cannot
+        # rewrite reviewer files and then use the rewritten text as its own
+        # completion proof.
+        def expectation(ctx)
+          reviewer_names = Hive::Stages::Review::Triage.discover_reviewer_files(ctx).map do |path|
+            path.delete_prefix("#{ctx.task_folder}/")
+          end
+          reviewer_digests = Hive::ProtectedFiles.snapshot(ctx.task_folder, reviewer_names)
+          escalations = Hive::Stages::Review::Triage.escalations_path(ctx)
+          escalation_digest = if File.file?(escalations)
+            name = escalations.delete_prefix("#{ctx.task_folder}/")
+            [ name, Hive::ProtectedFiles.snapshot(ctx.task_folder, [ name ]).fetch(name) ]
+          end
+          finding_ids = Hive::Stages::Review.collect_accepted_findings_with_count(ctx).finding_ids
+          Expectation.new(
+            reviewer_digests.freeze,
+            escalation_digest&.freeze,
+            finding_ids.freeze
+          )
+        end
+
+        def probe(ctx:, task_slug:, pass_start_head:, expectation:)
+          evidence = read_evidence(ctx, task_slug, expectation)
+          return evidence if evidence[:accepted] == false
+
+          review_state = validate_review_artifacts(ctx, expectation)
+          return review_state unless review_state[:accepted]
+
+          worktree = validate_worktree(ctx.worktree_path)
+          return worktree unless worktree[:accepted]
+
+          data = evidence.fetch(:evidence)
+          if data.fetch("outcome") == "changed"
+            validate_changed(ctx, task_slug, pass_start_head, data, review_state, expectation)
+          else
+            validate_no_changes(ctx, pass_start_head, data, review_state)
+          end
+        rescue SystemCallError, IOError => e
+          reject("completion evidence could not be read: #{e.class}: #{e.message}")
+        end
+
+        def read_evidence(ctx, task_slug, expectation)
+          path = evidence_path(ctx)
+          return reject("completion evidence missing: #{path}") unless File.file?(path)
+
+          data = JSON.parse(File.read(path))
+          return reject("completion evidence must be a JSON object") unless data.is_a?(Hash)
+
+          required = %w[
+            version pass task_slug outcome rationale findings commits
+            unresolved_escalation missing_output
+          ]
+          unknown = data.keys - required
+          missing = required - data.keys
+          return reject("completion evidence has unexpected fields: #{unknown.join(',')}") unless unknown.empty?
+          return reject("completion evidence missing fields: #{missing.join(',')}") unless missing.empty?
+          return reject("completion evidence version is unsupported") unless data["version"] == VERSION
+          return reject("completion evidence pass does not match current pass") unless data["pass"] == ctx.pass
+          return reject("completion evidence task slug does not match") unless data["task_slug"] == task_slug
+          return reject("completion evidence outcome is invalid") unless OUTCOMES.include?(data["outcome"])
+          return reject("completion evidence rationale is required") unless nonempty_string?(data["rationale"])
+          finding_error = validate_findings(data["findings"], expectation.finding_ids)
+          return reject(finding_error) if finding_error
+          disposition_error = validate_outcome_dispositions(data["outcome"], data["findings"])
+          return reject(disposition_error) if disposition_error
+          return reject("completion evidence commits are invalid") unless data["commits"].is_a?(Array) &&
+                                                                  data["commits"].all? { |sha| sha.is_a?(String) && sha.match?(SHA) }
+          return reject("completion evidence must explicitly clear unresolved escalation") unless data["unresolved_escalation"] == false
+          return reject("completion evidence must explicitly clear missing output") unless data["missing_output"] == false
+
+          if data["outcome"] == "changed" && data["commits"].empty?
+            return reject("changed completion evidence must claim at least one commit")
+          end
+          if data["outcome"] == "no_changes_needed" && !data["commits"].empty?
+            return reject("no-change completion evidence cannot claim commits")
+          end
+
+          { accepted: true, evidence: data, artifacts_checked: [ path ] }
+        rescue JSON::ParserError => e
+          reject("completion evidence invalid JSON: #{e.message}")
+        end
+
+        def validate_review_artifacts(ctx, expectation)
+          return reject("completion expectation is invalid") unless expectation.is_a?(Expectation)
+
+          reviewer_files = Hive::Stages::Review::Triage.discover_reviewer_files(ctx)
+          return reject("required reviewer outputs are missing") if reviewer_files.empty?
+          reviewer_names = reviewer_files.map { |path| path.delete_prefix("#{ctx.task_folder}/") }
+          unless reviewer_names == expectation.reviewer_digests.keys
+            return reject("reviewer artifact set changed after fix dispatch")
+          end
+
+          reviewer_files.each do |path|
+            content = File.read(path)
+            return reject("required reviewer output is empty: #{path}") if content.strip.empty?
+          end
+          current = Hive::ProtectedFiles.snapshot(ctx.task_folder, reviewer_names)
+          unless Hive::ProtectedFiles.diff(expectation.reviewer_digests, current).empty?
+            return reject("reviewer artifact changed after fix dispatch")
+          end
+
+          if expectation.escalation_digest
+            name, digest = expectation.escalation_digest
+            path = File.join(ctx.task_folder, name)
+            return reject("required escalation artifact is missing: #{path}") unless File.file?(path)
+            current = Hive::ProtectedFiles.snapshot(ctx.task_folder, [ name ])
+            unless current.fetch(name) == digest
+              return reject("escalation artifact changed after fix dispatch: #{path}")
+            end
+          end
+
+          return reject("accepted findings changed after fix dispatch") unless
+            Hive::Stages::Review.collect_accepted_findings_with_count(ctx).finding_ids == expectation.finding_ids
+
+          errors_path = File.join(ctx.task_folder, "reviews", "errors-#{format('%02d', ctx.pass)}.md")
+          if File.file?(errors_path) && !File.read(errors_path).strip.empty?
+            return reject("reviewer output error marker remains: #{errors_path}")
+          end
+          if Hive::Stages::Review.count_escalations(ctx).positive?
+            return reject("unresolved escalation remains for this pass")
+          end
+
+          artifacts = reviewer_files + [ expectation.escalation_digest&.first, errors_path ].compact
+          { accepted: true, artifacts_checked: artifacts }
+        rescue SystemCallError, IOError => e
+          reject("required review artifacts are unreadable: #{e.class}: #{e.message}")
+        end
+
+        def validate_worktree(worktree_path)
+          out, err, status = capture3_with_timeout("git", "-C", worktree_path, "status", "--porcelain")
+          return reject("worktree is unreadable: #{err.to_s.strip}") unless status.success?
+          return reject("worktree has uncommitted changes") unless out.to_s.empty?
+
+          { accepted: true }
+        rescue Timeout::Error
+          reject("worktree git status timed out after #{GIT_PROBE_TIMEOUT_SEC}s")
+        rescue SystemCallError => e
+          reject("worktree is unreadable: #{e.class}: #{e.message}")
+        end
+
+        def validate_changed(ctx, task_slug, pass_start_head, data, review_state, expectation)
+          head = git(ctx.worktree_path, "rev-parse", "HEAD")
+          return reject("worktree HEAD is unreadable") unless head
+          return reject("changed completion did not advance HEAD") if head == pass_start_head
+          return reject("changed completion HEAD does not descend from pass start") unless
+            git_success?(ctx.worktree_path, "merge-base", "--is-ancestor", pass_start_head, head)
+
+          range = "#{pass_start_head}..#{head}"
+          range_commits = git(ctx.worktree_path, "rev-list", range)&.lines&.map(&:strip) || []
+          claimed_commits = data.fetch("commits")
+          unless claimed_commits.sort == range_commits.sort
+            return reject("changed completion must claim every commit in the pass range")
+          end
+
+          findings_claimed = 0
+          range_commits.each do |sha|
+            trailers = commit_trailers(ctx.worktree_path, sha)
+            return reject("claimed commit is missing review-fix provenance: #{sha}") unless
+              valid_fix_trailers?(trailers, task_slug, ctx.pass)
+            changed_paths = git(ctx.worktree_path, "diff-tree", "--no-commit-id", "--name-only", "-r", sha)
+            return reject("claimed commit does not change any files: #{sha}") if changed_paths.to_s.empty?
+
+            findings_claimed += trailers.fetch("Hive-Fix-Findings").to_i
+          end
+          unless findings_claimed == expectation.finding_ids.length
+            return reject(
+              "review-fix commit trailers claim #{findings_claimed} findings, " \
+              "expected #{expectation.finding_ids.length}"
+            )
+          end
+
+          accept(
+            artifacts_checked: review_state.fetch(:artifacts_checked) + [ evidence_path(ctx) ],
+            commit_range: range,
+            outcome: "changed"
+          )
+        end
+
+        def validate_no_changes(ctx, pass_start_head, data, review_state)
+          head = git(ctx.worktree_path, "rev-parse", "HEAD")
+          return reject("worktree HEAD is unreadable") unless head
+          return reject("no-change completion must not advance HEAD") unless head == pass_start_head
+
+          accept(
+            artifacts_checked: review_state.fetch(:artifacts_checked) + [ evidence_path(ctx) ],
+            no_change_rationale: data.fetch("rationale"),
+            outcome: "no_changes_needed"
+          )
+        end
+
+        def validate_findings(findings, expected_ids)
+          return "completion evidence findings must exactly match accepted findings" unless
+            findings.is_a?(Array) && !findings.empty?
+
+          ids = []
+          findings.each do |finding|
+            unless finding.is_a?(Hash) && (finding.keys - %w[id disposition]).empty? &&
+                   nonempty_string?(finding["id"])
+              return "completion evidence findings are malformed"
+            end
+            unless DISPOSITIONS.include?(finding["disposition"])
+              return "completion evidence finding disposition is invalid"
+            end
+            ids << finding["id"]
+          end
+          return "completion evidence finding ids must be unique" unless ids.uniq.length == ids.length
+          return "completion evidence findings must exactly match accepted findings" unless ids.sort == expected_ids.sort
+
+          nil
+        end
+
+        def validate_outcome_dispositions(outcome, findings)
+          dispositions = findings.map { |finding| finding.fetch("disposition") }
+          if outcome == "no_changes_needed" && dispositions.any? { |value| value != "no change needed" }
+            return "no-change completion requires every finding disposition to be no change needed"
+          end
+          if outcome == "changed" && dispositions.none?("addressed")
+            return "changed completion requires at least one addressed finding disposition"
+          end
+
+          nil
+        end
+
+        def valid_fix_trailers?(trailers, task_slug, pass)
+          return false unless trailers
+
+          trailers["Hive-Task-Slug"] == task_slug &&
+            trailers["Hive-Fix-Pass"] == format("%02d", pass) &&
+            trailers["Hive-Fix-Phase"] == "fix" &&
+            trailers["Hive-Triage-Bias"].to_s != "" &&
+            trailers["Hive-Reviewer-Sources"].to_s != "" &&
+            trailers["Hive-Fix-Findings"].to_s.match?(/\A[1-9]\d*\z/)
+        end
+
+        def commit_trailers(worktree_path, sha)
+          body = git(worktree_path, "show", "-s", "--format=%B", sha)
+          return nil unless body
+
+          out, _err, status = capture3_with_timeout(
+            "git", "interpret-trailers", "--parse", stdin_data: body
+          )
+          return nil unless status.success?
+
+          out.lines.each_with_object({}) do |line, trailers|
+            key, value = line.split(":", 2)
+            trailers[key] = value.to_s.strip if key
+          end
+        rescue SystemCallError, Timeout::Error
+          nil
+        end
+
+        # Successful git commands that have no stdout return an empty String.
+        # `nil` exclusively means execution/status failure.
+        def git(worktree_path, *args)
+          out, _err, status = capture3_with_timeout("git", "-C", worktree_path, *args)
+          status.success? ? out.to_s.strip : nil
+        rescue SystemCallError, Timeout::Error
+          nil
+        end
+
+        def git_success?(worktree_path, *args)
+          _out, _err, status = capture3_with_timeout("git", "-C", worktree_path, *args)
+          status.success?
+        rescue SystemCallError, Timeout::Error
+          false
+        end
+
+        def capture3_with_timeout(*args, **kwargs)
+          Timeout.timeout(GIT_PROBE_TIMEOUT_SEC) { Open3.capture3(*args, **kwargs) }
+        end
+
+        def nonempty_string?(value)
+          value.is_a?(String) && !value.strip.empty?
+        end
+
+        def accept(**fields)
+          { accepted: true, **fields }
+        end
+
+        def reject(reason)
+          { accepted: false, rejection_reason: reason, artifacts_checked: [] }
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/stop_hook_installer.rb b/lib/hive/stop_hook_installer.rb
index 237887af..bd74b7f8 100644
--- a/lib/hive/stop_hook_installer.rb
+++ b/lib/hive/stop_hook_installer.rb
@@ -6,29 +6,51 @@ module Hive
   module StopHookInstaller
     HOOK_PATH = File.expand_path("scripts/stop_hook.sh", __dir__)
     BACKUP_SUFFIX = ".hive-pre-install"
+    DONE_FILENAME = ".done"
+    RESULT_FILENAME = "result.json"
 
     module_function
 
-    def install(stage_dir:, extra_dirs: [])
-      paths = [ install_at(stage_dir, stage_dir) ]
-      # Claude resolves `.claude/settings.json` from the process cwd, not
-      # from --add-dir paths. Stages that launch with cwd != task.folder
-      # (4-execute / 6-review reviewers run in the feature worktree)
-      # never saw the stop-hook config under task.folder, so the .done
-      # / result.json signal files were never written and waits in
-      # 5-open-pr / 6-review CI-fix could hang until timeout. Install a
-      # second copy in each extra dir so Claude finds the hook
-      # regardless of cwd.
-      Array(extra_dirs).each do |dir|
-        next if dir.to_s.empty?
-        next if File.expand_path(dir) == File.expand_path(stage_dir)
+    # The launcher owns the completion files, but settings can be resolved
+    # from either the task folder or the launch cwd. Keep the two absolute
+    # paths as one explicit contract instead of reconstructing them in the
+    # installer and shell hook independently. The current paths are aligned;
+    # an absent/late Stop callback from Claude's persistent interactive
+    # process remains the likely (but not yet live-reproduced) failure mode.
+    def completion_paths(stage_dir)
+      stage_dir = File.expand_path(stage_dir)
+      [ File.join(stage_dir, DONE_FILENAME), File.join(stage_dir, RESULT_FILENAME) ]
+    end
+
+    def install(stage_dir:, extra_dirs: [], done_path: nil, result_path: nil)
+      default_done, default_result = completion_paths(stage_dir)
+      done_path ||= default_done
+      result_path ||= default_result
+      paths = []
+      begin
+        paths << install_at(stage_dir, stage_dir, done_path: done_path, result_path: result_path)
+        # Claude resolves `.claude/settings.json` from the process cwd, not
+        # from --add-dir paths. Stages that launch with cwd != task.folder
+        # (4-execute / 6-review reviewers run in the feature worktree)
+        # never saw the stop-hook config under task.folder, so the .done
+        # / result.json signal files were never written and waits in
+        # 5-open-pr / 6-review CI-fix could hang until timeout. Install a
+        # second copy in each extra dir so Claude finds the hook
+        # regardless of cwd.
+        Array(extra_dirs).each do |dir|
+          next if dir.to_s.empty?
+          next if File.expand_path(dir) == File.expand_path(stage_dir)
 
-        paths << install_at(dir, stage_dir)
+          paths << install_at(dir, stage_dir, done_path: done_path, result_path: result_path)
+        end
+        paths
+      rescue StandardError
+        paths.uniq.reverse_each { |path| rollback_installation(path) }
+        raise
       end
-      paths
     end
 
-    def install_at(target_dir, stage_dir)
+    def install_at(target_dir, stage_dir, done_path:, result_path:)
       claude_dir = File.join(target_dir, ".claude")
       FileUtils.mkdir_p(claude_dir)
       settings_path = File.join(claude_dir, "settings.json")
@@ -54,18 +76,44 @@ module Hive
       # previous file before re-writing (it may already be 0o444 from a
       # prior install), then chmod 0o444 so the OS rejects any further
       # write before Claude's tool layer can apply it.
+      mutation_started = true
       File.delete(settings_path) if File.exist?(settings_path)
-      File.write(settings_path, JSON.pretty_generate(settings(stage_dir)) + "\n")
+      File.write(settings_path, JSON.pretty_generate(settings(
+        stage_dir,
+        done_path: File.expand_path(done_path),
+        result_path: File.expand_path(result_path)
+      )) + "\n")
       File.chmod(0o444, settings_path)
       settings_path
+    rescue StandardError
+      rollback_installation(settings_path) if mutation_started
+      raise
+    end
+
+    def rollback_installation(settings_path)
+      backup_path = "#{settings_path}#{BACKUP_SUFFIX}"
+      if File.exist?(backup_path)
+        File.chmod(0o644, settings_path) if File.exist?(settings_path)
+        FileUtils.mv(backup_path, settings_path)
+      else
+        File.delete(settings_path) if File.exist?(settings_path)
+        claude_dir = File.dirname(settings_path)
+        Dir.rmdir(claude_dir) if Dir.exist?(claude_dir) && Dir.empty?(claude_dir)
+      end
+      nil
+    rescue Errno::ENOENT, Errno::ENOTEMPTY
+      nil
     end
 
     # Real Claude Code expects each Stop entry to be a matcher group whose
     # `hooks` array carries handler descriptors with `type: "command"` and a
-    # shell-string `command`. HIVE_TASK_STAGE_DIR is propagated by prefixing
-    # the command with a shell `VAR=… script` assignment, since Claude Code
-    # invokes the command via a shell and there is no per-hook `env` field.
-    def settings(stage_dir)
+    # shell-string `command`. Claude Code invokes the command through a shell
+    # and has no per-hook `env` field, so all resolved control-plane paths are
+    # safely serialized as shell assignments here.
+    def settings(stage_dir, done_path: nil, result_path: nil)
+      default_done, default_result = completion_paths(stage_dir)
+      done_path ||= default_done
+      result_path ||= default_result
       {
         "hooks" => {
           "Stop" => [
@@ -73,7 +121,12 @@ module Hive
               "hooks" => [
                 {
                   "type" => "command",
-                  "command" => "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(stage_dir)} #{Shellwords.escape(HOOK_PATH)}"
+                  "command" => [
+                    "HIVE_TASK_STAGE_DIR=#{Shellwords.escape(File.expand_path(stage_dir))}",
+                    "HIVE_STOP_HOOK_DONE_PATH=#{Shellwords.escape(File.expand_path(done_path))}",
+                    "HIVE_STOP_HOOK_RESULT_PATH=#{Shellwords.escape(File.expand_path(result_path))}",
+                    Shellwords.escape(HOOK_PATH)
+                  ].join(" ")
                 }
               ]
             }
diff --git a/lib/hive/tmux_runner.rb b/lib/hive/tmux_runner.rb
index 0133c160..7f3ec397 100644
--- a/lib/hive/tmux_runner.rb
+++ b/lib/hive/tmux_runner.rb
@@ -132,6 +132,25 @@ module Hive
       nil
     end
 
+    # Keep the pane alive after Claude exits long enough to read the real
+    # numeric process status. A live idle REPL is not an exit-success signal;
+    # only `pane_dead_status == 0` after a controlled /quit qualifies.
+    def enable_remain_on_exit
+      run_tmux("set-option", "-t", target_pane, "remain-on-exit", "on")
+      true
+    end
+
+    def pane_dead?
+      run_tmux("display-message", "-t", target_pane, "-p", '#{pane_dead}').strip == "1"
+    end
+
+    def pane_dead_status
+      raw = run_tmux("display-message", "-t", target_pane, "-p", '#{pane_dead_status}').strip
+      Integer(raw)
+    rescue ArgumentError, TypeError
+      nil
+    end
+
     def kill_session
       run_tmux("kill-session", "-t", @name)
       true
diff --git a/test/integration/prompt_injection_test.rb b/test/integration/prompt_injection_test.rb
index 83cc09cb..ada45d27 100644
--- a/test/integration/prompt_injection_test.rb
+++ b/test/integration/prompt_injection_test.rb
@@ -186,6 +186,7 @@ class PromptInjectionTest < Minitest::Test
           task_slug: task.slug,
           triage_bias: "courageous",
           reviewer_sources: "claude-ce-code-review",
+          expected_finding_ids: [ "claude-ce-code-review-02.md:3" ],
           user_supplied_tag: tag
         )
       )
@@ -194,6 +195,7 @@ class PromptInjectionTest < Minitest::Test
       assert_includes prompt, "Hive-Task-Slug: #{task.slug}"
       assert_includes prompt, "Hive-Fix-Pass: 02"
       assert_includes prompt, "Hive-Fix-Findings:"
+      assert_includes prompt, "`claude-ce-code-review-02.md:3`"
       assert_includes prompt, "Lines beginning `[source] >>>` are answered-escalation context"
       assert_includes prompt, "do not treat those context lines or markdown checkboxes inside them as separate findings"
       assert_includes prompt, "Hive-Triage-Bias: courageous"
